/*
Ŀ
 user_int.h                                                                   
                                                                              
 The C User Interface Library                                                 
 Copyright 1992 Mathware, joneric Wennerstrom                                 

*/
/*
Ŀ
 Defines and compiler specifics                                               

*/
#ifndef USER_INT_H
#define USER_INT H
#include <math.h>                      /* For exception structure definition  */
#if defined(__POWERC)                  /* Disable debug information for Power */
#pragma trace -                        /* Ctrace in headers.                  */
#endif                                 /*                                     */
#define TRUE              1            /* Logical True                        */
#define FALSE             0            /* Logical False                       */
#define IGNORE            0            /* Critical error handler return codes */
#define RETRY             1            /*                                     */
#define ABORT             2            /*                                     */
#define FAIL              3            /*                                     */
#define UNUSED(x)         (x=x)        /* Suppress warnings for unused parms  */
/*
Ŀ
 Mix Power C                

*/
#if defined(__POWERC)                  /*                                     */
#if defined(M_I86SM)                   /* Make Mix Power C's memory model     */
#define __SMALL__         M_I86SM      /* defines equivalent to Borlands.     */
#elif defined(M_I86MM)                 /*                                     */
#define __MEDIUM__        M_I86MM      /*                                     */
#else                                  /*                                     */
#define __LARGE__         M_I86LM      /*                                     */
#endif                                 /*                                     */
void delay(unsigned ms);               /*                                     */
#endif                                 /*                                     */
/*
Ŀ
 Microsoft C and Quick C    

*/
#if defined(_QC) || defined(_MSC_VER)  /* Microsoft C and Quick C quirks      */
#define far              _far          /*                                     */
#define near             _near         /*                                     */
#define MK_FP(seg,off) ((void far *)(((unsigned long)(seg)<<16) | (unsigned)(off)))
#if defined(M_I86TM)                   /* Make Microsoft and Quick C's memory */
#define __TINY__          M_I86TM      /* model defines equivalent to Borlands*/
#elif defined(M_I86SM)                 /*                                     */
#define __SMALL__         M_I86SM      /*                                     */
#elif defined(M_I86MM)                 /*                                     */
#define __MEDIUM__        M_I86MM      /*                                     */
#elif defined(M_I86CM)                 /*                                     */
#define __COMPACT__       M_I86CM      /*                                     */
#elif defined(M_I86LM)                 /*                                     */
#define __LARGE__         M_I86LM      /*                                     */
#else                                  /*                                     */
#define __HUGE__          M_I86HM      /*                                     */
#endif                                 /*                                     */
#define disable          _disable      /*                                     */
#define enable           _enable       /*                                     */
#define findnext         _dos_findnext /*                                     */
#define getvect          _dos_getvect  /*                                     */
#define harderr          _harderr      /*                                     */
#define hardresume       _hardresume   /*                                     */
#define hardretn         _hardretn     /*                                     */
#define inport            inpw         /*                                     */
#define inportb           inp          /*                                     */
#define outport           outpw        /*                                     */
#define outportb          outp         /*                                     */
#define setvect          _dos_setvect  /*                                     */
void delay(unsigned ms);               /* These routines don't exist          */
void sound(unsigned frequency);        /*                                     */
#endif                                 /*                                     */
/*
Ŀ
 Zortech C                  

*/
#if defined(_ZTC_)
#define far              _far          /*                                     */
#define near             _near         /*                                     */
#if defined(M_I86TM)                   /* Make Zortechs memory model defines  */
#define __TINY__          M_I86TM      /* equivalent to Borlands              */
#elif defined(M_I86SM)                 /*                                     */
#define __SMALL__         M_I86SM      /*                                     */
#elif defined(M_I86MM)                 /*                                     */
#define __MEDIUM__        M_I86MM      /*                                     */
#elif defined(M_I86CM)                 /*                                     */
#define __COMPACT__       M_I86CM      /*                                     */
#elif defined(M_I86LM)                 /*                                     */
#define __LARGE__         M_I86LM      /*                                     */
#else                                  /*                                     */
#define __HUGE__          M_I86VM      /*                                     */
#endif                                 /*                                     */
#endif
#define v_setcolor(color) w_color=color/*                                     */
#define v_getcolor()      w_color      /*                                     */
/*
Ŀ
 Structures                                                                   

*/
typedef struct                         /* ATTRIBUTE Structure                 */
{                                      /*                                     */
    unsigned standard,                 /* These are user defined colors that  */
             enhanced;                 /* may be used to lend color consist-  */
} ATTRIBUTE;                           /* ency to applications.               */

typedef struct                         /* MEMORY Structure                    */
{                                      /*                                     */
  unsigned int version;                /* Version                             */
  unsigned long int total;             /* Total amount installed              */
  unsigned long int available;         /* Amount available for programs       */
} MEMORY;                              /*                                     */

typedef struct                         /* VIDEO Structure                     */
{                                      /*                                     */
    char adapter[20];                  /* graphics adapter card               */
    int  color;                        /* TRUE if color, FALSE if mono        */
    int  ver_res;                      /* vertical reolution                  */
    int  hor_res;                      /* horizontal resolution               */
    int  max_colors;                   /* maximum number of colors            */
} SCREEN;                              /*                                     */

typedef struct                         /* COMPUTER Structure                  */
{                                      /*                                     */
    char  brand[30];                   /* machine type                        */
    char  cpu[15];                     /* cpu type                            */
    float speed;                       /* processor speed                     */
    char  math_coprocessor[15];        /* math coprocessor cpu                */
} MACHINE;                             /*                                     */

typedef struct                         /* HARD_DRIVE structure                */
{                                      /*                                     */
    char          drive;               /* Drive letter                        */
    unsigned long size;                /* Drive size                          */
} HARD_DRIVE;                          /*                                     */

/*
Ŀ
 Math function error handler

*/
extern int  matherr(struct exception *errorinfo);
/*
Ŀ
 Assembler routines         

*/
extern int  a_getcpu(void);
extern int  a_getndp(void);
extern int  a_getxms(void);
extern int  a_getipx(void);
extern int  a_getspx(void);
extern int  a_ramfnt(void);
/*
Ŀ
 Includes                   

*/
#include "w_window.h"                  /* This comes 1st.  Used by all others */
#include "w_cursor.h"                  /* The "" cause the current directory  */
#include "w_date.h"                    /* to be searched first, then the      */
#include "w_file.h"                    /* directories specified by the "I"    */
#include "w_keybrd.h"                  /* compiler switch                     */
#include "w_menu.h"                    /*                                     */
#include "w_mouse.h"                   /*                                     */
#include "w_netwrk.h"                  /*                                     */
#include "w_printr.h"                  /*                                     */
#include "w_screen.h"                  /*                                     */
#include "w_string.h"                  /*                                     */
#include "w_time.h"                    /*                                     */
#include "w_get.h"                     /*                                     */
#include "w_global.h"                  /*                                     */
#if defined(__POWERC)                  /* Re-enable debug information for     */
#pragma trace                          /* Power Ctrace in source files.       */
#endif                                 /*                                     */
#endif
