/*
Ŀ
 w_file.h                                                                     
                                                                              
 The C User Interface Library                                                 
 Copyright 1992 Mathware, joneric Wennerstrom                                 

/*
Ŀ
 Defines                                                                      

*/
#include <stdio.h>                     /* For FILE structure definition       */
#ifndef W_FILE_H
#define W_FILE_H
#if defined(__POWERC)                  /* Disable debug information for Power */
#pragma trace -                        /* Ctrace in headers.                  */
#endif                                 /*                                     */
#if !defined(__POWERC)                 /*                                     */
#define FA_NORMAL           0x00       /* File types used by m_filebox        */
#define FA_RDONLY           0x01       /*                                     */
#define FA_HIDDEN           0x02       /*                                     */
#define FA_SYSTEM           0x04       /*                                     */
#define FA_LABEL            0x08       /*                                     */
#define FA_DIREC            0x10       /*                                     */
#define FA_ARCH             0x20       /*                                     */
#define FA_SHARE            0x80       /* Available only on a network         */
#define FA_TRANSACTION      0x10       /* Extended network file attributes    */
#define FA_INDEX            0x20       /*                                     */
#define FA_R_AUDIT          0x40       /*                                     */
#define FA_W_AUDITT         0x80       /*                                     */
#define FX_NORMAL           0x0000     /* Additional extended file attributes */
#define FX_READ_ONLY        0x0001l    /*                                     */
#define FX_HIDDEN           0x0002l    /*                                     */
#define FX_SYSTEM           0x0004l    /*                                     */
#define FX_EXECUTE_ONLY     0x0008l    /*                                     */
#define FX_DIRECTORY        0x0010l    /*                                     */
#define FX_NEEDS_ARCHIVED   0x0020l    /*                                     */
#define FX_EXECUTE_CONFIRM  0x0040l    /*                                     */
#define FX_SHAREABLE        0x0080l    /*                                     */
#define FX_LOW_SEARCH       0x0100l    /*                                     */
#define FX_MID_SEARCH       0x0200l    /*                                     */
#define FX_HI_SEARCH        0x0400l    /*                                     */
#define FX_PRIVATE          0x0800l    /*                                     */
#define FX_TRANSACTION      0x1000l    /*                                     */
#define FX_INDEX            0x2000l    /*                                     */
#define FX_RD_AUDIT         0x4000l    /*                                     */
#define FX_WR_AUDIT         0x8000l    /*                                     */
#define FX_PURGE           0x10000l    /*                                     */
#define FX_RENAME_INHIBIT  0x20000l    /*                                     */
#define FX_DELETE_INHIBIT  0x40000l    /*                                     */
#define FX_COPY_INHIBIT    0x80000l    /*                                     */
#define TR_NONE             0x00       /* Trustee access rights               */
#define TR_READ             0x01       /*                                     */
#define TR_WRITE            0x02       /*                                     */
#define TR_OPEN             0x04       /*                                     */
#define TR_CREATE           0x08       /*                                     */
#define TR_DELETE           0x10       /*                                     */
#define TR_PARENT           0x20       /*                                     */
#define TR_SEARCH           0x40       /*                                     */
#define TR_MODIFY           0x80       /*                                     */
#define TR_ALL              0xFF       /*                                     */
#endif                                 /*                                     */
#define F_MAX_DOS_PATH_LEN  128        /* Max length of DOS path name         */
#define BROWSE              0          /* Mode used by f_edit                 */
#define EDIT                1          /*                                     */
#define MAX_VIR_WIDTH       256        /*                                     */
#define MAX_LINES           3000       /* Maximum number of lines allowed for */
                                       /* a file to have when edited/browsed  */
/*
Ŀ
 Function Prototypes                                                          

*/
extern int   f_copy(char *srce_file,char *dest_file,char mode);
extern int   f_delete(char *file);
extern int   f_edit(int row,int col,int hgt,int wth,int vir_wth,char *file_name,
             ATTRIBUTE text_color,ATTRIBUTE block_color,int edit,int shad,
			 int indicators,char *title,char *help);
extern int   f_filebox(int row,int col,int num_rows,int num_cols,char *filename,
             char *file_ext,int file_type);
extern FILE *f_fileio(int row,char *file_path,char mode_,char translation,
             int m_row,int m_col,int m_num_rows,int m_num_cols,
             char *m_file_ext,int m_file_type,char *help_word);
extern char *f_fullpath(char *filename, char fullpath[128]);
extern char  f_getdisk(void);
extern char *f_searchpath(char *file_name);
#if defined(__POWERC)                  /* Re-enable debug information for     */
#pragma trace                          /* Power Ctrace in source files.       */
#endif                                 /*                                     */
#endif
