/*
Ŀ
 w_keybrd.h                                                                   
                                                                              
 The C User Interface Library                                                 
 Copyright 1992 Mathware, joneric Wennerstrom                                 

*/
/*
Ŀ
 Defines                                                                      

*/
#ifndef W_KEYBRD_H
#define W_KEYBRD_H
#if defined(__POWERC)                  /* Disable debug information for Power */
#pragma trace -                        /* Ctrace in headers.                  */
#endif                                 /*                                     */
#define K_MENU 0                       /* Wait states from which a function   */
#define K_READ 1                       /* key press is possible.  These are   */
#define K_WAIT 2                       /* the types that are passed to k_FXX  */
#define K_SCRL 3                       /* functions.                          */
#define K_EDIT 4                       /*                                     */
/*
Ŀ
 Control keys               

*/
#define       BELL      7
#define       ENTER     13
#define  CTRL_ENTER     10
#define   ALT_ENTER     156
#define SHIFT_ENTER     13
#define       ESC       27
#define     BLANK       32
#define       INS       210
#define  CTRL_INS       274
#define   ALT_INS       290
#define SHIFT_INS       210
#define       DEL       211
#define  CTRL_DEL       275
#define   ALT_DEL       291
#define SHIFT_DEL       211
#define       HOME      199
#define  CTRL_HOME      247
#define   ALT_HOME      279
#define SHIFT_HOME      199
#define       END       207
#define  CTRL_END       245
#define   ALT_END       287
#define SHIFT_END       207
#define       PG_UP     201
#define  CTRL_PG_UP     260
#define   ALT_PG_UP     281
#define SHIFT_PG_UP     201
#define       PG_DN     209
#define  CTRL_PG_DN     246
#define   ALT_PG_DN     289
#define SHIFT_PG_DN     209
#define       TAB       9
#define  CTRL_TAB       276
#define   ALT_TAB       293
#define SHIFT_TAB       143
#define       SPACEBAR  32
#define       BACKSPACE 8
#define  CTRL_BACKSPACE 127
#define   ALT_BACKSPACE 142
#define  CTRL_C         3
/*
Ŀ
 Arrow keys                 

*/
#define       LT_ARROW  203
#define  CTRL_LT_ARROW  243
#define   ALT_LT_ARROW  283
#define SHIFT_LT_ARROW  201
#define       RT_ARROW  205
#define  CTRL_RT_ARROW  244
#define   ALT_RT_ARROW  285
#define SHIFT_RT_ARROW  205
#define       UP_ARROW  200
#define  CTRL_UP_ARROW  269
#define   ALT_UP_ARROW  280
#define SHIFT_UP_ARROW  200
#define       DN_ARROW  208
#define  CTRL_DN_ARROW  273
#define   ALT_DN_ARROW  288
#define SHIFT_DN_ARROW  208
/*
Ŀ
 Function keys              

*/
#define       F1        187
#define  CTRL_F1        222
#define   ALT_F1        232
#define SHIFT_F1        212
#define       F2        188
#define  CTRL_F2        223
#define   ALT_F2        233
#define SHIFT_F2        213
#define       F3        189
#define  CTRL_F3        224
#define   ALT_F3        234
#define SHIFT_F3        214
#define       F4        190
#define  CTRL_F4        225
#define   ALT_F4        235
#define SHIFT_F4        215
#define       F5        191
#define  CTRL_F5        226
#define   ALT_F5        236
#define SHIFT_F5        216
#define       F6        192
#define  CTRL_F6        227
#define   ALT_F6        237
#define SHIFT_F6        217
#define       F7        193
#define  CTRL_F7        228
#define   ALT_F7        238
#define SHIFT_F7        218
#define       F8        194
#define  CTRL_F8        229
#define   ALT_F8        239
#define SHIFT_F8        219
#define       F9        195
#define  CTRL_F9        230
#define   ALT_F9        240
#define SHIFT_F9        220
#define       F10       196
#define  CTRL_F10       231
#define   ALT_F10       241
#define SHIFT_F10       221
#define       F11       261
#define  CTRL_F11       265
#define   ALT_F11       267
#define SHIFT_F11       263
#define       F12       262
#define  CTRL_F12       266
#define   ALT_F12       268
#define SHIFT_F12       264
#define      HELP_KEY    F1
/*
Ŀ
 Letters                    

*/
#define    CTRL_A         1
#define     ALT_A       178
#define    CTRL_B         2
#define     ALT_B       176
#define    CTRL_C         3
#define     ALT_C       174
#define    CTRL_D         4
#define     ALT_D       160
#define    CTRL_E         5
#define     ALT_E       146
#define    CTRL_F         6
#define     ALT_F       161
#define    CTRL_G         7
#define     ALT_G       162
#define    CTRL_H         8
#define     ALT_H       178
#define    CTRL_I         9
#define     ALT_I       151
#define    CTRL_J        10
#define     ALT_J       164
#define    CTRL_K        11
#define     ALT_K       165
#define    CTRL_L        12
#define     ALT_L       166
#define    CTRL_M        13
#define     ALT_M       178
#define    CTRL_N        14
#define     ALT_N       177
#define    CTRL_O        15
#define     ALT_O       152
#define    CTRL_P        16
#define     ALT_P       153
#define    CTRL_Q        17
#define     ALT_Q       144
#define    CTRL_R        18
#define     ALT_R       147
#define    CTRL_S        19
#define     ALT_S       159
#define    CTRL_T        20
#define     ALT_T       148
#define    CTRL_U        21
#define     ALT_U       150
#define    CTRL_V        22
#define     ALT_V       175
#define    CTRL_W        23
#define     ALT_W       145
#define    CTRL_X        24
#define     ALT_X       173
#define    CTRL_Y        25
#define     ALT_Y       149
#define    CTRL_Z        26
#define     ALT_Z       172
/*
Ŀ
 Keyboard Shift Flags       

*/
#define RT_SHIFT       0x01
#define LT_SHIFT       0x02
#define CTRL           0x04
#define ALT            0x08
#define SCROLL_LOCK    0x10
#define NUM_LOCK       0x20
#define CAPS_LOCK      0x40
#define INSERT         0x80

/*
Ŀ
 Function Prototypes                                                          

*/
extern void         k_beep(void);
extern void         k_flush(void);
extern void         k_fun_def(int type, void *ptr,int indx,char *help_word);
extern void         k_fun_exec(unsigned int key,int type,void *ptr,int indx,
                    char *help_word);
extern unsigned int k_getkey(void);
extern void         k_help_def(int type, void *ptr,int indx,char *help_word);
extern int          k_isfun(unsigned int key);
extern void interrupt far k_INT_09(void);
extern void         k_putkey(unsigned int key);
extern void         k_set(unsigned int key,void (*k_fun)(int type,void *ptr,
                    int indx,char *help_word));
extern int          k_status(int Shift_flag);
extern unsigned int k_wait(char *help_word);
#if defined(__POWERC)                  /* Re-enable debug information for     */
#pragma trace                          /* Power Ctrace in source files.       */
#endif                                 /*                                     */
#endif
