/*
Ŀ
 w_menu.h                                                                     
                                                                              
 The C User Interface Library                                                 
 Copyright 1992 Mathware, joneric Wennerstrom                                 

*/
/*
Ŀ
 Defines                                                                      

*/
#ifndef W_MENU_H
#define W_MENU_H
#if defined(__POWERC)                  /* Disable debug information for Power */
#pragma trace -                        /* Ctrace in headers.                  */
#endif                                 /*                                     */
#define M_BOTH          0              /* Menu Type                           */
#define M_HORZ          1              /*                                     */
#define M_VERT          2              /*                                     */
#define M_SELECTABLE    1              /* Menu items availability             */
#define M_UNSELECTABLE  0              /*                                     */
#define M_ESC          -1              /* Menus return -1 if user preses ESC  */
#define M_NO_BORDER     0              /* Bordered menus                      */
#define M_BORDER        1              /* Borderless menus                    */
#define M_NO_SHADOW     0              /* Shadowed menus                      */
#define M_SHADOW        1              /* Shadowless menus                    */
#define M_CLOSE         0              /* Close menu when done                */
#define M_OPEN          1              /* Leave menu open when done           */
#define M_LINE          0              /* Menu choice line seperator          */
#define MAX_NUM_FILES 512              /* Max # of files allowed in m_filebox */
/*
Ŀ
 Structures                                                                   

*/
typedef struct MEN_ITEM
{
   int   row;                           /* Row of menu item                   */
   int   col;                           /* Col of menu item                   */
   char *text;                          /* Text of menu item                  */
   char *help;                          /* Help key word                      */
   char  sel;                           /* If menu item is selectable         */
}  MEN_ITEM;

typedef struct MEN_DATA
{
   WIN_PTR   wndw;                     /* Menu window                        */
   int       open;                     /* Leave Menu open flag               */
   int       index;                    /* Initially selected menu item       */
   int       start;                    /* Index to start at if !reset flag   */
   int       num_items;                /* Number of menu items               */
   MEN_ITEM *scrn;                     /* Menu items                         */
}  MENU;
typedef struct MEN_DATA *MEN_PTR;
/*
Ŀ
 Macros                     

*/
#define m_isopen(menu)                 w_isopen((MEN_PTR)(menu)->windw)
/*
Ŀ
 Function Prototypes                                                          

*/
extern void m_close(MEN_PTR *menu);
extern int  m_filebox(int row,int col,int num_rows,int num_cols,ATTRIBUTE color,
                      WIN_PTR *window_ptr,int shdw,char *title,char *help_word,
                      char *directory,char *file_spec,int file_type,
                      char *sel_file);
extern int  m_listbox(int row,int col,int num_rows,int num_cols,ATTRIBUTE color,
                      WIN_PTR *window_ptr,int num_items,int item_len,char *items[],
                      int shdw,char *title,char *help_word,char selected[]);
extern int  m_menu(int row,int col,int hgt,int len,ATTRIBUTE color,int menu_type,
                      int border,int shdw,int open,int num_items,int index,
                      MEN_PTR *menu_ptr,MEN_ITEM menu_item[]);
extern int  m_scrlbox(int row,int col,int num_rows,int num_cols,ATTRIBUTE color,
                      WIN_PTR *window_ptr,int num_items,int item_len,char *items[],
                      int shdw,char *title,char *help_word,char *selected,
                      unsigned int alt_sel);
extern int  m_scrollmenu(int row,int col,int num_rows,int num_cols,ATTRIBUTE color,
                      WIN_PTR *window_ptr,int num_items,int item_len,char *items[],
                      int shdw,char *title,char *help_word);
#if defined(__POWERC)                  /* Re-enable debug information for     */
#pragma trace                          /* Power Ctrace in source files.       */
#endif                                 /*                                     */
#endif
