/*
Ŀ
 w_mouse.h                                                                    
                                                                              
 The C User Interface Library                                                 
 Copyright 1992 Mathware, joneric Wennerstrom                                 

*/
/*
Ŀ
 Defines                                                                      

*/
#ifndef W_MOUSE_H
#define W_MOUSE_H
#if defined(__POWERC)                  /* Disable debug information for Power */
#pragma trace -                        /* Ctrace in headers.                  */
#endif                                 /*                                     */
#define M_LEFT       0                 /* Mouse buttons                       */
#define M_RIGHT      1                 /*                                     */
#define M_CENTER     2                 /*                                     */
#define M_SIDE_CNRS  0                 /* Put mouse corners on side only      */
#define M_ALL_CNRS   1                 /* Put mouse corners on all 4 corners  */
#define M_UNKNOWN    0                 /* Mouse types                         */
#define M_BUS        1                 /*                                     */
#define M_SERIAL     2                 /*                                     */
#define M_INPORT     3                 /*                                     */
#define M_PS_2       4                 /*                                     */
#define M_HP         5                 /*                                     */
/*
Ŀ
 Structures                                                                   

*/
typedef struct MOUSE_DATA
{
   int       installed,                /* Flag if mouse is installed          */
             version,                  /* Driver version in BCD               */
             type,                     /* Mouse type                          */
             irq,                      /* Interrupt line used                 */
             num_buttons,              /* Number of buttons on mouse          */
             cursor,                   /* Cursor On/Off flag                  */
             pix_row,                  /* Pixel  row                          */
             pix_col,                  /* Pixel  column                       */
             txt_row,                  /* Text   row                          */
             txt_col,                  /* Text   column                       */
             rht_but,                  /* Right  button pressed flag          */
             lft_but,                  /* Left   button pressed flag          */
             cnt_but;                  /* Center button pressed flag          */
   char far *copyright;                /* Copyright notice in mouse driver    */
} MOUSE;
/*
Ŀ
 Function Prototypes                                                          

*/
extern void m_button(void);
extern char far *m_copyright(void);
extern void m_curon(void);
extern void m_curoff(void);
extern void m_debounce(void);
extern int  m_double(int button);
extern void m_getcur(void);
extern int  m_getpress(int button);
extern int  m_getrelease(int button);
extern void m_graphcur(int row,int col,int bitmap[32]);
extern void m_init(void);
extern unsigned int m_keytrans(int mouse_cnrs[4][2]);
extern int  m_motion(void);
extern void m_setcnrs(WIN_PTR window,int mouse_cnrs[4][2],int cnrs);
extern void m_setcur(int txt_row,int txt_col);
extern void m_sethor(int lft_lim,int rht_lim);
extern void m_setver(int low_lim,int upp_lim);
extern void m_textcur(int screen_mask,int cursor_mask);
extern int  m_version(void);
#if defined(__POWERC)                  /* Re-enable debug information for     */
#pragma trace                          /* Power Ctrace in source files.       */
#endif                                 /*                                     */
#endif
