/*
Ŀ
 w_netwrk.h - Network functions                                               
                                                                              
 The C User Interface Library                                                 
 Copyright 1992 Mathware, joneric Wennerstrom                                 

*/
/*
Ŀ
 Defines                    

*/
#ifndef W_NETWRK_H
#define W_NETWRK_H
#if defined(__POWERC)                    /* Disable debug information for Mix */
#pragma trace -                          /* Power Ctrace in headers.          */
#endif                                   /*                                   */
#define N_IPX_OPEN_SOCKET          0x00  /* IPX services                      */
#define N_IPX_CLOSE_SOCKET         0x01  /*                                   */
#define N_IPX_GET_LOCAL_TARGET     0x02  /*                                   */
#define N_IPX_SEND_PACKET          0x03  /*                                   */
#define N_IPX_LISTEN_PACKET        0x04  /*                                   */
#define N_IPX_SCHEDULE_EVENT       0x05  /*                                   */
#define N_IPX_CANCEL_EVENT         0x06  /*                                   */
#define N_IPX_GET_INTERVAL_MARKER  0x08  /*                                   */
#define N_IPX_GET_NETWORK_ADDRESS  0x09  /*                                   */
#define N_IPX_RELINQUISH_CONTROL   0x0A  /*                                   */
#define N_IPX_DISCONNECT_TARGET    0x0B  /*                                   */
#define N_SPX_INITIALIZE           0x10  /* SPX services                      */
#define N_SPX_ESTABLISH_CONNECTION 0x11  /*                                   */
#define N_SPX_LISTEN_CONNECTION    0x12  /*                                   */
#define N_SPX_TERMINATE_CONNECTION 0x13  /*                                   */
#define N_SPX_ABORT_CONNECTION     0x14  /*                                   */
#define N_SPX_CONNECTION_STATUS    0x15  /*                                   */
#define N_SPX_SEND_PACKET          0x16  /*                                   */
#define N_SPX_LISTEN_PACKET        0x17  /*                                   */
#define N_UNKNOWN                  0x0000/* Bindery Object types              */
#define N_USER                     0x0001/*                                   */
#define N_USER_GROUP               0x0002/*                                   */
#define N_PRINT_QUEUE              0x0003/*                                   */
#define N_FILE_SERVER              0x0004/*                                   */
#define N_JOB_SERVER               0x0005/*                                   */
#define N_GATEWAY                  0x0006/*                                   */
#define N_PRINT_SERVER             0x0007/*                                   */
#define N_ARCHIVE_QUEUE            0x0008/*                                   */
#define N_ARCHIVE_SERVER           0x0009/*                                   */
#define N_JOB_QUEUE                0x000A/*                                   */
#define N_ADMINISTRATION           0x000B/*                                   */
#define N_REMOTE_BRIDGE            0x0026/*                                   */
#define N_LOGGED_IN_USER           0x0027/* Defined by Mathware, not Novell.  */
                                         /* May only be used with             */
                                         /* n_bindery_obj_list.  Undefined for*/
                                         /* all other network functions.      */
                                         /* Predefined Netware properties     */
#define N_ACCOUNT_BALANCE         "ACCOUNT_BALANCE"
#define N_ACCOUNT_HOLDS           "ACCOUNT_HOLDS"
#define N_ACCOUNT_LOCKOUT         "ACCOUNT_LOCKOUT"
#define N_ACCOUNT_SERVERS         "ACCOUNT_SERVERS"
#define N_BLOCKS_READ             "BLOCKS_READ"
#define N_BLOCKS_WRITTEN          "BLOCKS_WRITTEN"
#define N_CONNECT_TIME            "CONNECT_TIME"
#define N_DISK_STORAGE            "DISK_STORAGE"
#define N_GROUP_MEMBERS           "GROUP_MEMBERS"
#define N_GROUPS_IM_IN            "GROUPS_I'M_IN"
#define N_IDENTIFICATION          "IDENTIFICATION"
#define N_LOGIN_CONTROL           "LOGIN_CONTROL"
#define N_NET_ADDRESS             "NET_ADDRESS"
#define N_NODE_CONTROL            "NODE_CONTROL"
#define N_OLD_PASSWORDS           "OLD_PASSWORDS"
#define N_OPERATORS               "OPERATORS"
#define N_PASSWORD                "PASSWORD"
#define N_Q_DIRECTORY             "Q_DIRECTORY"
#define N_Q_OPERATORS             "Q_OPERATORS"
#define N_Q_SERVERS               "Q_SERVERS"
#define N_Q_USERS                 "Q_USERS"
#define N_REQUESTS_MADE           "REQUESTS_MADE"
#define N_SECURITY_EQUALS         "SECURITY_EQUALS"
#define N_USER_DEFAULTS           "USER_DEFAULTS"
#define N_READ_SEC_ANYONE          0x00  /* Security read nibble mask         */
#define N_READ_SEC_LOGGED_IN       0x01  /*                                   */
#define N_READ_SEC_OBJECT          0x02  /*                                   */
#define N_READ_SEC_SUPERVISOR      0x03  /*                                   */
#define N_READ_SEC_NETWARE         0x04  /*                                   */
#define N_WRITE_SEC_ANYONE         0x04  /* Security write nibble mask        */
#define N_WRITE_SEC_LOGGED_IN      0x05  /*                                   */
#define N_WRITE_SEC_OBJECT         0x06  /*                                   */
#define N_WRITE_SEC_SUPERVISOR     0x07  /*                                   */
#define N_WRITE_SEC_NETWARE        0x08  /*                                   */
#define N_STATIC                   0x00  /* Flag byte mask                    */
#define N_DYNAMIC                  0x01  /*                                   */
#define N_ITEM                     0x00  /* These 2 values are for properties */
#define N_SET                      0x02  /* only.                             */
#define N_MAX_NUM_OBJECTS          256   /* Maximum # objects in scan fnctions*/
#define N_OBJECT_NAME_LEN          48    /* Maximum length of an object's name*/
#define N_PROPERTY_NAME_LEN        16    /* Maximum length of a property's nam*/
#define N_VALUE_LEN                128   /* Maximum length of a value         */
#define N_OBJECT_LIST_LEN          30    /* Length of object names in list    */
#define N_PROPERTY_LIST_LEN        16    /* Length of property names in list  */
#define N_VALUE_LIST_LEN           30    /* Length of value names in list     */
#define N_WILD_CARD_TYPE           0xFFFF/*                                   */
#define N_WILD_CARD_ID             0xFFFFFFFFl
#define N_WILD_CARD_NAME           "*\0" /*                                   */
#define N_WILD_CARD_SEQUENCE_NUM   0xFFFFFFFFl
#define N_BANNER                   0x80  /* Capture Print flag                */
#define N_CONVERT_TABS             0x40  /*                                   */
#define N_NOTIFY_USER              0x10  /*                                   */
#define N_NO_FORM_FEED             0x08  /*                                   */
#define N_PRINT_JOB_INTERRUPTED    0x04  /*                                   */
#if !defined(__POWERC)                   /*                                   */
#define FA_RDONLY                  0x01  /* Normal DOS file attributes        */
#define FA_HIDDEN                  0x02  /*                                   */
#define FA_SYSTEM                  0x04  /*                                   */
#define FA_LABEL                   0x08  /*                                   */
#define FA_DIREC                   0x10  /*                                   */
#define FA_ARCH                    0x20  /*                                   */
#endif                                   /*                                   */
#define FA_SHARE                   0x80  /*                                   */
#define FA_TRANSACTION             0x10  /* Extended network file attributes  */
#define FA_INDEX                   0x20  /*                                   */
#define FA_R_AUDIT                 0x40  /*                                   */
#define FA_W_AUDIT                 0x80  /*                                   */
#define FX_NORMAL                0x0000  /* Additional extended file attribute*/
#define FX_READ_ONLY             0x0001l /*                                   */
#define FX_HIDDEN                0x0002l /*                                   */
#define FX_SYSTEM                0x0004l /*                                   */
#define FX_EXECUTE_ONLY          0x0008l /*                                   */
#define FX_DIRECTORY             0x0010l /*                                   */
#define FX_NEEDS_ARCHIVED        0x0020l /*                                   */
#define FX_EXECUTE_CONFIRM       0x0040l /*                                   */
#define FX_SHAREABLE             0x0080l /*                                   */
#define FX_LOW_SEARCH            0x0100l /*                                   */
#define FX_MID_SEARCH            0x0200l /*                                   */
#define FX_HI_SEARCH             0x0400l /*                                   */
#define FX_PRIVATE               0x0800l /*                                   */
#define FX_TRANSACTION           0x1000l /*                                   */
#define FX_INDEX                 0x2000l /*                                   */
#define FX_RD_AUDIT              0x4000l /*                                   */
#define FX_WR_AUDIT              0x8000l /*                                   */
#define FX_PURGE                0x10000l /*                                   */
#define FX_RENAME_INHIBIT       0x20000l /*                                   */
#define FX_DELETE_INHIBIT       0x40000l /*                                   */
#define FX_COPY_INHIBIT         0x80000l /*                                   */
#define N_DIR_NONE                  0x00 /* Directory rights                  */
#define N_DIR_READ                  0x01 /*                                   */
#define N_DIR_WRITE                 0x02 /*                                   */
#define N_DIR_OPEN                  0x04 /*                                   */
#define N_DIR_CREATE                0x08 /*                                   */
#define N_DIR_DELETE                0x10 /*                                   */
#define N_DIR_PARENT                0x20 /*                                   */
#define N_DIR_SEARCH                0x40 /*                                   */
#define N_DIR_MODIFY                0x80 /*                                   */
#define N_DIR_ALL                   0xFF /*                                   */
#define N_CURRENT_DIR               0x00 /* Miscellaneous                     */
#define N_CURRENT_DRIVE             0x00 /*                                   */
#define N_LOCAL_DRIVE               0x00 /*                                   */
#define N_NETWORK_DRIVE             0x01 /*                                   */
/*
Ŀ
 Macros                     

*/
#define n_int(number)     ((number & 0x00FF)<<8)+((number & 0xFF00)>>8)
#define n_long(number)    ((number & 0x000000FF)<<24)+((number & 0x0000FF00)<<8)+((number & 0x00FF0000)>>8)+((number & 0xFF000000)>>24)
/*
Ŀ
 Structures                 

*/
typedef struct                         /* Bindery Object                      */
{                                      /* All objects in the Novell Bindery   */
    unsigned long id;                  /* have these fields                   */
    unsigned int  type;                /*                                     */
    char          name[48];            /*                                     */
    unsigned char flag;                /*                                     */
    unsigned char security;            /*                                     */
    unsigned char property;            /* TRUE if object has properties       */
}   N_BINDERY_OBJECT;                  /*                                     */

typedef struct                         /*                                     */
{                                      /*                                     */
    char          name[16];            /*                                     */
    unsigned char flag;                /*                                     */
    unsigned char security;            /*                                     */
    unsigned long sequence_num;        /*                                     */
    unsigned char value;               /* TRUE if Property has values         */
}   N_BINDERY_PROPERTY;                /*                                     */

typedef struct                         /*                                     */
{                                      /*                                     */
    unsigned char value[N_VALUE_LEN];  /*                                     */
    unsigned char more_segments;       /* True if there are more values       */
    unsigned char flag;                /* located in other segments           */
}   N_BINDERY_VALUE;                   /*                                     */

typedef struct                         /*                                     */
{                                      /*                                     */
    unsigned char connection_number;   /*                                     */
    unsigned long network_number;      /*                                     */
    unsigned char network_node[6];     /*                                     */
    unsigned long object_id;           /*                                     */
             char name[48];            /*                                     */
}   N_USER_ID;                         /*                                     */

typedef struct                         /*                                     */
{                                      /*                                     */
    int      installed;                /* TRUE if IPX     is installed        */
    int      SPX;                      /* TRUE if SPX     is installed        */
    int      TTS;                      /* TRUE if TTS     is installed        */
    int      SHARE;                    /* TRUE if SHARE   is installed        */
    int      NETBIOS;                  /* TRUE if NETBIOS is installed        */
    unsigned int version;              /* Network version in BCD              */
}   N_NETWORK;                         /*                                     */

typedef struct                         /* NETBIOS NCB                         */
{                                      /* (Network Control Block)             */
    unsigned char NCB_COMMAND;         /*                                     */
    unsigned char NCB_RETCODE;         /*                                     */
    unsigned char NCB_LSN;             /*                                     */
    unsigned char NCB_NUM;             /*                                     */
    void far     *NCB_NCB_BUFFER_PTR;  /*                                     */
    unsigned char NCB_NCB_LENGTH;      /*                                     */
    unsigned char NCB_CALLNAME[16];    /*                                     */
    unsigned char NCB_RTO;             /*                                     */
    unsigned char NCB_STO;             /*                                     */
    #if defined(_QC) || defined(_MSC_VER)
    void (interrupt far *POST_FUNC)(void);
    #else                              /*                                     */
    void interrupt (*POST_FUNC)(void); /*                                     */
    #endif                             /*                                     */
    unsigned char NCB_LANA_NUM;        /*                                     */
    unsigned char NCB_CMD_CPLT;        /*                                     */
    unsigned char NCB_RESERVED[14];    /*                                     */
}   N_NCB;                             /*                                     */

typedef struct                         /*                                     */
{                                      /*                                     */
    unsigned char status;              /* Status may not be modified.         */
    unsigned char print_flag;          /* From this field up to and including */
    unsigned char tab_size;            /* the form name, may be modified by   */
    unsigned char print_server;        /* using n_capture_set().              */
    unsigned char num_copies;          /*                                     */
    unsigned char form_type;           /*                                     */
    unsigned char reserved_1;          /*                                     */
    unsigned char banner[13];          /*                                     */
    unsigned char reserved_2;          /*                                     */
    unsigned char local_lpt;           /*                                     */
    unsigned int  timeout_cntr;        /*                                     */
    unsigned char autoendcap;          /*                                     */
    unsigned int  lines_per_page;      /*  */
    unsigned int  chars_per_line;      /* Fields below are for netware 2.1 +  */
    unsigned char form_name[13];       /*  */
    unsigned char lpt_flag;            /* The rest of these fields may not be */
    unsigned char file_flag;           /* modified.  They are used internally */
    unsigned char timeout_flag;        /* Novell.                             */
    char far     *setup_string_ptr;    /*                                     */
    char far     *reset_string_ptr;    /*                                     */
    unsigned char cnct_id_q_print_job; /*                                     */
    unsigned char in_progress;         /*                                     */
    unsigned char print_queue_flag;    /*                                     */
    unsigned char print_job_valid;     /*                                     */
    unsigned long print_queue_id;      /*                                     */
    unsigned int  print_job_number;    /*                                     */
}   N_PRINT_CONTROL;                   /*                                     */

typedef struct                         /*                                     */
{                                      /*                                     */
    void far *address;                 /*                                     */
    unsigned int length;               /*                                     */
}   N_PACKET;                          /*                                     */

typedef struct                         /*                                     */
{                                      /*                                     */
    void far     *link_address;        /*                                     */
    #if defined(_QC) || defined(_MSC_VER)
    void (far *event_service_rtn)(void);/*                                    */
    #else                              /*                                     */
    void far (*event_service_rtn)(void);/*                                    */
    #endif                             /*                                     */
    unsigned char in_use;              /*                                     */
    unsigned char completion_code;     /*                                     */
    unsigned int  socket_number;       /*                                     */
    unsigned int  connection_id;       /*                                     */
    unsigned char reserved[2];         /*                                     */
    unsigned char driver_workspace[12];/*                                     */
    unsigned char immediate_address[6];/*                                     */
    unsigned int  packet_count;        /*                                     */
    N_PACKET      packet[2];           /*                                     */
}   N_ECB;                             /*                                     */

typedef struct
{
    unsigned int  check_sum;           /*                                     */
    unsigned int  length;              /*                                     */
    unsigned char transport_control;   /*                                     */
    unsigned char packet_type;         /*                                     */
    unsigned char dest_network_num[4]; /*                                     */
    unsigned char dest_network_node[6];/*                                     */
    unsigned int  dest_network_socket; /*                                     */
    unsigned char srce_network_num[4]; /*                                     */
    unsigned char srce_network_node[6];/*                                     */
    unsigned int  srce_network_socket; /*                                     */
}   N_IPX_HEADER;                      /*                                     */

typedef struct                         /*                                     */
{                                      /*                                     */
    unsigned int  check_sum;           /*                                     */
    unsigned int  length;              /*                                     */
    unsigned char transport_control;   /*                                     */
    unsigned char packet_type;         /*                                     */
    unsigned char dest_network_num[4]; /*                                     */
    unsigned char dest_network_node[6];/*                                     */
    unsigned int  dest_network_socket; /*                                     */
    unsigned char srce_network_num[4]; /*                                     */
    unsigned char srce_network_node[6];/*                                     */
    unsigned char connection_control;  /*                                     */
    unsigned char datastream_type;     /*                                     */
    unsigned int  srce_connection_id;  /*                                     */
    unsigned int  dest_connection_id;  /*                                     */
    unsigned int  sequence_number;     /*                                     */
    unsigned int  acknowledge_number;  /*                                     */
    unsigned int  allocation_number;   /*                                     */
}   N_SPX_HEADER;                      /*                                     */
/*
Ŀ
 Functions                  

*/
extern int           n_bindery_default_server(void);
extern unsigned long n_bindery_object_id(char *object_name,unsigned object_type);
extern int           n_bindery_object_list(int row,int col,int num_rows,
                     int num_cols,ATTRIBUTE color,WIN_PTR *window,
                     N_BINDERY_OBJECT *object,unsigned int object_type,int shdw,
                     char *title,char *help_word);
extern int           n_bindery_object_name(unsigned long object_id,
                     char *object_name);
extern int           n_bindery_object_scan(N_BINDERY_OBJECT *object);
extern int           n_bindery_property_list(int row,int col,int num_rows,
                     int num_cols,ATTRIBUTE color,WIN_PTR *window,
                     N_BINDERY_PROPERTY *property,char *object_name,
                     unsigned int object_type,int shdw,char *title,
                     char *help_word);
extern int           n_bindery_property_scan(N_BINDERY_PROPERTY *property,
                     char *object_name,unsigned int object_type);
extern int           n_bindery_value_list(int row,int col,int num_rows,
                     int num_cols,ATTRIBUTE color,WIN_PTR *window,
                     N_BINDERY_VALUE *value,char *object_name,
                     unsigned int object_type,char *property_name,int shdw,
                     char *title,char *help_word);
extern int           n_bindery_value_name(char *property_name,
                     N_BINDERY_VALUE value,int index,char *value_name);
extern int           n_bindery_value_scan(char *object_name,
                     unsigned int object_type,char *property_name,
                     unsigned char segment,N_BINDERY_VALUE *value);
extern int           n_capture_active(void);
extern int           n_capture_banner_get(char *banner_name);
extern int           n_capture_banner_set(char *banner_name);
extern int           n_capture_cancel(unsigned char LPT);
extern int           n_capture_end(unsigned char LPT);
extern int           n_capture_file(char *file_path);
extern int           n_capture_flush(unsigned char LPT);
extern int           n_capture_get(unsigned char LPT,N_PRINT_CONTROL *capture);
extern int           n_capture_queue(unsigned char LPT,unsigned long queue_id);
extern int           n_capture_set(unsigned char LPT,N_PRINT_CONTROL  capture);
extern int           n_capture_start(unsigned char LPT);
extern int           n_capture_timeout_set(unsigned char LPT,int new_timeout);
extern unsigned char n_connection_number(char *user_name);
extern int           n_dir_get_effective_rights(char *dir,unsigned char *rights);
extern int           n_dir_get_maximum_rights(char *dir,unsigned char *rights);
extern int           n_dir_get_trustee_rights(char *dir,unsigned char *rights);
extern unsigned char n_dir_handle(char drive);
extern int           n_dir_set_trustee_rights(char *dir,unsigned char rights);
extern int           n_file_get_ext_attr(char *file,unsigned char *ext_attr);
extern int           n_file_set_ext_attr(char *file,unsigned char  ext_attr);
extern int           n_internet_address(unsigned char connection_number,
                     unsigned long int *network_number,
                     unsigned char *network_node);
extern int           n_IPX(void);
extern int           n_IPX_close_socket(N_ECB *ecb);
extern void          n_IPX_listen_packet(N_ECB *ecb_ptr);
extern int           n_IPX_open_socket(unsigned int socket);
extern void          n_IPX_send_packet(N_ECB *ecb_ptr);
extern unsigned char n_local_connection_number(void);
extern int           n_NETBIOS(void);
extern int           n_network_drive(char drive);
extern int           n_server_attach(unsigned char server_id);
extern int           n_server_detach(unsigned char server_id);
extern int           n_server_login(char *name,char *password);
extern void          n_server_logout(void);
extern int           n_SHARE(void);
extern int           n_SPX(void);
extern int           n_TTS(void);
extern int           n_user_name(unsigned char connection_number,
                     char *user_name);
extern int           n_version(void);
#if defined(__POWERC)                  /* Re-enable debug information for Mix */
#pragma trace                          /* Power Ctrace in source files.       */
#endif                                 /*                                     */
#endif
