/*
Ŀ
 w_printr.h                                                                   
                                                                              
 The C User Interface Library                                                 
 Copyright 1992 Mathware, joneric Wennerstrom                                 

*/
/*
Ŀ
 Defines                                                                      

*/
#ifndef W_PRINTR_H
#define W_PRINTR_H
#if defined(__POWERC)                  /* Disable debug information for Power */
#pragma trace -                        /* Ctrace in headers.                  */
#endif                                 /*                                     */
#define NOT_REDIRECTED     -1          /* Printer is not redirected to a file */
#define LPT1                0          /* Parallel ports                      */
#define LPT2                1          /*                                     */
#define LPT3                2          /*                                     */
#define COM1                3          /* Serial ports                        */
#define COM2                4          /*                                     */
#define COM3                5          /*                                     */
#define COM4                6          /*                                     */

#define P_WAITING_FOR_JOB   0          /* Network print status codes          */
#define P_WAITING_FOR_FORM  1          /*                                     */
#define P_PRINTING_JOB      2          /*                                     */
#define P_PAUSED            3          /*                                     */
#define P_STOPPED           4          /*                                     */
#define P_MARK_EJECT        5          /*                                     */
#define P_READY_TO_GO_DOWN  6          /*                                     */
#define P_NOT_CONNECTED     7          /*                                     */
#define P_PRIVATE           8          /*                                     */
#define OFF                 0          /* On\Off                              */
#define ON                  1          /*                                     */
#define P_EOF             255          /* Ascii char that marks end of command*/
#define P_NUM_COMMANDS     52          /* Number of printer commands supported*/
#define P_COMMAND_SIZE     16          /* Maximum size of a printer command   */
#define P_MODEL_LENGTH     25          /* Maximum length of printer name      */
#define P_NUM_STATUS_CODES  4          /* Number of status codes supported    */
#define P_NUM_INIT_STRINGS  1          /* Number of printer init strings      */
#define P_NUM_CHAR_SETS     2          /* Number of Character sets supported  */
#define P_NUM_QUALITIES     2          /* Number of Qualities supported       */
#define P_NUM_FONTS        10          /* Number of Fonts supported           */
#define P_NUM_STYLES        8          /* Number of Styles supported          */
#define P_NUM_COLORS        8          /* Number of Colors supported          */
#define P_NUM_HEIGHTS       3          /* Number of Heights supported         */
#define P_NUM_WIDTHS        3          /* Number of Widths supported          */
#define P_NUM_ORIENTATIONS  2          /* Number of Orientations supported    */
#define P_NUM_GRAPHICS      0          /* Number of Graphic commands supported*/
#define P_STATUS            0          /* 4  Status codes :  0-3              */
#define P_EMUL              4          /* Internal Emulation command          */
#define P_INIT              5          /* 1  printer init string              */
#define P_CHAR_SET          6          /* 2  Char Sets    :  5-6              */
#define P_QUALITY           8          /* 2  Qualities    :  7-8              */
#define P_FONT             10          /* 10 Fonts        :  9-18             */
#define P_STYLE            20          /* 8  Styles       : 19-34             */
#define P_COLOR            36          /* 8  Colors       : 35-42             */
#define P_HEIGHT           44          /* 3 Heights       : 43-45             */
#define P_WIDTH            47          /* 3 Widths        : 46-48             */
#define P_ORIENTATION      50          /* 2 Orientations  : 49-50             */
#define P_GRAPHICS         52          /* 0 Graphics      : 51-               */
#define P_ON_OFFLINE        0          /* Printer Status codes                */
#define P_ON_OUT_OF_PAPER   1          /*                                     */
#define P_ON_ONLINE         2          /*                                     */
#define P_OFF               3          /*                                     */
#define P_SET_1             0          /* Printer Character Sets              */
#define P_SET_2             1          /*                                     */
#define P_DRAFT_QUALITY     0          /* Printer Qualitys                    */
#define P_LETTER_QUALITY    1          /*                                     */
#define P_ROMAN             0          /* Printer Fonts                       */
#define P_SANS_SERIF        1          /*                                     */
#define P_COURIER           2          /*                                     */
#define P_PRESTIGE          3          /*                                     */
#define P_SCRIPT            4          /*                                     */
#define P_RESERVED          5          /*                                     */
#define P_BOLD              6          /*                                     */
#define P_ORATOR            7          /*                                     */
#define P_HELVITICA         8          /*                                     */
#define P_GOTHIC            9          /*                                     */
#define P_EMPHASIZED        0          /* Printer styles                      */
#define P_UNDERLINED        2          /*                                     */
#define P_ITALIC            4          /*                                     */
#define P_SUBSCRIPT         6          /*                                     */
#define P_SUPERSCRIPT       8          /*                                     */
#define P_CONDENSED        10          /*                                     */
#define P_EXPANDED         12          /*                                     */
#define P_PROPORTIONAL     14          /*                                     */
#define P_BLACK             0          /* Printer Colors                      */
#define P_MAGENTA           1          /*                                     */
#define P_CYAN              2          /*                                     */
#define P_VIOLET            3          /*                                     */
#define P_YELLOW            4          /*                                     */
#define P_ORANGE            5          /*                                     */
#define P_GREEN             6          /*                                     */
#define P_BROWN             7          /*                                     */
#define P_SINGLE_HEIGHT     0          /* Printer Character heights           */
#define P_DOUBLE_HEIGHT     1          /*                                     */
#define P_QUAD_HEIGHT       2          /*                                     */
#define P_SINGLE_WIDTH      0          /* Printer Character widths            */
#define P_DOUBLE_WIDTH      1          /*                                     */
#define P_QUAD_WIDTH        2          /*                                     */
#define P_PORTRAIT          0          /* Printer Orientations                */
#define P_LANDSCAPE         1          /*                                     */
#define P_FORM_FEED        12          /* Printer Control Characters          */
#define P_EJECT            12          /* Another name for Form feed          */
#define P_LINE_FEED        10          /*                                     */
#define P_CAR_RET          13          /*                                     */
#define p_isredirected()   (w_printer.redirected.flag!=NOT_REDIRECTED)
/*
Ŀ
 Structures                                                                   

*/
typedef struct                         /*                                     */
{                                      /*                                     */
    char flag;                         /* TRUE if redirected to a disk file   */
    char path[128];                    /* Name of file                        */
    FILE *handle;                      /* If not on a network, DOS file handle*/
}   REDIRECT;                          /* else, set to 0 or 1.                */
typedef struct
{
    char            model[3][P_MODEL_LENGTH+1],     /* Name of printer        */
                    emulation[3][P_MODEL_LENGTH+1]; /* Emulation commands     */
    N_PRINT_CONTROL old_capture;       /* Novell capture setup for default LPT*/
    unsigned char   cur_port;          /* Currently selected port             */
    REDIRECT        redirected;        /* Whether printer redirected to file  */
    unsigned char **commands;          /* Escape sequence commands            */
    int             num_printers;      /* Number of printers in database      */
    int             num_ports;         /* Number of parallel ports available  */
} PRINTER;
/*
Ŀ
 Function Prototypes                                                          

*/
extern int           p_char_set(int set);
extern unsigned char p_code(unsigned char LPT);
extern int           p_command_exec(int command);
extern int           p_command_read(char *printer,char emul[4][P_MODEL_LENGTH+1]);
extern void          p_command_to_bin(char *cmnd,unsigned char *bin);
extern int           p_color(int color);
extern void          p_end(WIN_PTR window);
extern int           p_font(int font);
extern char         *p_getname(char *printer);
extern int           p_height(int height);
extern int           p_init(void);
extern char          p_IO_error(void);
extern int           p_orientation(int orientation);
extern int           p_pause(void);
extern int           p_prtchr(char chr);
extern int           p_prtf(char *format,...);
extern int           p_quality(int quality);
extern int           p_redirect(char *file);
extern int           p_restore(void);
extern void          p_set_port(unsigned char LPT);
extern WIN_PTR       p_start(void);
extern int           p_status(void);
extern int           p_style(int style, int flag);
extern int           p_width(int width);
#if defined(__POWERC)                  /* Re-enable debug information for     */
#pragma trace                          /* Power Ctrace in source files.       */
#endif                                 /*                                     */
#endif
