/*
Ŀ
 w_screen.h                                                                   
                                                                              
 The C User Interface Library                                                 
 Copyright 1992 Mathware, joneric Wennerstrom                                 

*/
/*
Ŀ
 Defines                                                                      

*/
#ifndef W_SCREEN_H
#define W_SCREEN_H
#if defined(__POWERC)                  /* Disable debug information for Power */
#pragma trace -                        /* Ctrace in headers.                  */
#endif                                 /*                                     */
/*
Ŀ
 Screen Styles              

*/
#define V_CLEAR     0                  /* Clear Screen                        */
#define V_TILED     1                  /* Tiled Screen                        */
#define V_CHECK     2                  /* Checkered Screen                    */
/*
Ŀ
 Screen Modes               

*/
#define V_25_40       0x01             /* Color - 25 rows x 40 columns        */
#define V_25_80       0x03             /* Color - 25 rows x 80 columns        */
#define V_MONO        0x07             /* Mono  - 25 rows x 80 columns        */
/*
Ŀ
 ROM FONTS                  

*/
#define V_FONT_8X8      0x12           /* Default Fonts located in ROM BIOS   */
#define V_FONT_8X14     0x11           /* Used by 25, 28, 43, 50 line screens */
#define V_FONT_8X16     0x14           /* in video mode 0x03                  */
#define V_FONT_9X16     0x0B           /*                                     */
/*
Ŀ
 SCAN LINES                 

*/
#define V_SCANLINES_200 0x00           /* Default Fonts located in ROM BIOS   */
#define V_SCANLINES_350 0x01           /* Used by 25, 28, 43, 50 line screens */
#define V_SCANLINES_400 0x02           /* in video mode 0x03                  */
#define V_SCANLINES_480 0x03           /* in video mode 0x03                  */
/*
Ŀ
  Function Prototypes                                                         

*/
extern void v_clear(int row,int col,int hgt,int len,int color);
extern int  v_getcols(void);
extern int  v_getmode(void);
extern void v_getmonitor(void);
extern int  v_getrows(void);
extern int  v_loadROMfont(unsigned char font);
extern void v_prtf(char *format,...);
extern int  v_restscrn(int row,int col,int hgt,int len,char *buffer);
extern char *v_savescrn(int row,int col,int hgt,int len);
extern void v_setaltprtscrn(void);
extern void v_setmode(int mode);
extern int  v_setrows(int rows);
extern int  v_setscanlines(int lines);
#if defined(__POWERC)                  /* Re-enable debug information for     */
#pragma trace                          /* Power Ctrace in source files.       */
#endif                                 /*                                     */
#endif
